#pragma once

#include "ActorInterface.h"
#include "WASCommand.h"
#include "WASActor.h"


class CWASGetEmployeeInfo : public CWASCommand
{
public:
	CWASGetEmployeeInfo(CWASActor *pActor);
	~CWASGetEmployeeInfo(void);

	void ExecuteAsync(void);

	void SetParameter(LPCWSTR strEmpsIDs, NTRequestEmpInfoType reqEmpInfoType, int nGroupID, LPCWSTR strFunction, LPCWSTR strLangCode)
	{
		m_strEmpIDs = strEmpsIDs;
		m_reqEmpInfoType = reqEmpInfoType;
		m_nGroupID = nGroupID;
		m_strFunction = strFunction;
		m_strLangCode = strLangCode;
	}

private:
	bool ParseAndEventFire(nfc::CIkXMLDom * pDom);

protected:
	// override in drived class
	virtual void OnWasResponse(trid_t /*trid*/, bool /*bSuccess*/, int /*nWinINetErrorCode*/, int /*nHttpResponseCode*/, 
		LPCSTR /*szWasResCodeInHeader*/, 
		LPCSTR /*szWasResCodeInXml*/,
		nfc::CIkXMLDom * /*pDom*/);

	virtual void OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/);


private:
	NTRequestEmpInfoType m_reqEmpInfoType;
	WSTRING m_strEmpIDs;
	std::vector<NE_MEMBER_DATA> m_listResultPrivate;
	int m_nGroupID;
	WSTRING m_strFunction;
	WSTRING m_strLangCode;
};
